<template>
    <v-row>
        <v-col cols="12">
            <data-table
                v-model="timeslots"
                endpoint="api/timeslots"
                :title="$tc('timeslot', 2)"
                :headers="headers"
                :force-fetch.sync="forceFetch"
            >
                <template v-slot:buttons>
                    <v-btn
                        class="mr-4"
                        color="primary"
                        @click="openCreateDialog = true"
                    >
                        <v-icon left>mdi-plus</v-icon>
                        {{ $tc('timeslot', 2) }}
                    </v-btn>
                </template>

                <template v-slot:item="{ item, index }">
                    <tr>
                        <td>{{ $t(item.type.name) }}</td>
                        <td>{{ item.start_time | time }}</td>
                        <td>{{ item.end_time | time }}</td>
                        <td class="text-right">{{ item.limit }}</td>
                        <td class="text-center">
                            <v-chip
                                :color="item.enabled ? 'success' : 'error'"
                                text-color="white"
                                label
                            >
                                {{ item.enabled ? $t('enabled') : $t('disabled') }}
                            </v-chip>
                        </td>
                        <td>
                            <v-menu
                                :close-on-content-click="false"
                                offset-y
                                bottom
                            >
                                <template v-slot:activator="{ on, attrs }">
                                    <v-btn
                                        color="primary"
                                        dark
                                        icon
                                        v-bind="attrs"
                                        v-on="on"
                                    >
                                        <v-icon>mdi-dots-horizontal</v-icon>
                                    </v-btn>
                                </template>

                                <v-list dense>
                                    <v-list-item>
                                        <v-btn
                                            class="text-capitalize"
                                            color="primary"
                                            text
                                            block
                                            @click="onEdit(item)"
                                        >
                                            <v-icon left>mdi-pencil</v-icon>
                                            {{ $t('edit') }}
                                        </v-btn>
                                    </v-list-item>
                                    <v-divider class="my-2"></v-divider>
                                    <v-list-item>
                                        <v-btn
                                            class="text-capitalize"
                                            color="error"
                                            text
                                            block
                                            @click="onDelete(item)"
                                        >
                                            <v-icon left>mdi-delete</v-icon>
                                            {{ $t('delete') }}
                                        </v-btn>
                                    </v-list-item>
                                </v-list>
                            </v-menu>
                        </td>
                    </tr>
                </template>
            </data-table>
        </v-col>

        <v-col cols="12">
            <v-sheet height="64">
                <v-toolbar
                    flat
                >
                    <v-btn
                        outlined
                        class="mr-4"
                        color="grey darken-2"
                        @click="setToday"
                    >
                        {{ $t('today') }}
                    </v-btn>
                    <v-btn
                        fab
                        text
                        small
                        color="grey darken-2"
                        @click="prev"
                    >
                        <v-icon small>mdi-arrow-left-thick</v-icon>
                    </v-btn>
                    <v-btn
                        fab
                        text
                        small
                        class="mr-4"
                        color="grey darken-2"
                        @click="next"
                    >
                        <v-icon small>mdi-arrow-right-thick</v-icon>
                    </v-btn>
                    <v-toolbar-title v-if="$refs.calendar">
                        {{ $refs.calendar.title }}
                    </v-toolbar-title>
                    <v-spacer></v-spacer>
                    <v-menu
                        bottom
                        right
                    >
                        <template v-slot:activator="{ on, attrs }">
                            <v-btn
                                outlined
                                color="grey darken-2"
                                v-bind="attrs"
                                v-on="on"
                            >
                                <span>{{ typeToLabel[type] }}</span>
                                <v-icon right>
                                    mdi-menu-down
                                </v-icon>
                            </v-btn>
                        </template>
                        <v-list>
                            <v-list-item @click="type = 'day'">
                                <v-list-item-title>{{ $t('day') }}</v-list-item-title>
                            </v-list-item>
                            <v-list-item @click="type = 'week'">
                                <v-list-item-title>{{ $t('week') }}</v-list-item-title>
                            </v-list-item>
                            <v-list-item @click="type = 'month'">
                                <v-list-item-title>{{ $t('month') }}</v-list-item-title>
                            </v-list-item>
                        </v-list>
                    </v-menu>
                </v-toolbar>
            </v-sheet>
            <v-sheet height="600">
                <v-progress-linear
                    v-show="eventLoading"
                    color="primary"
                    indeterminate
                ></v-progress-linear>
                <v-calendar
                    ref="calendar"
                    v-model="focus"
                    color="primary"
                    :events="events"
                    :weekdays="weekdays"
                    :type="type"
                    :event-color="getEventColor"
                    @click:event="showEvent"
                    @click:more="viewDay"
                    @click:date="viewDay"
                    @change="updateRange"
                ></v-calendar>
                <v-menu
                    v-model="selectedOpen"
                    :close-on-content-click="false"
                    :activator="selectedElement"
                    offset-x
                >
                    <v-card
                        color="grey lighten-4"
                        min-width="120px"
                        flat
                    >
                        <v-card-title>
                            <span>{{ selectedEvent.name }}</span>
                            <v-spacer></v-spacer>
                            <v-chip
                                label
                                color="primary"
                                text-color="white"
                                :to="`order/${selectedEvent.order_id}`"
                            >
                                {{ $tc('order', 1) }} #{{ selectedEvent.order_id }}
                            </v-chip>
                        </v-card-title>
                        <v-card-text>
                            <div class="field-label">{{ selectedEvent.name === $t('deliver') ?  $t('delivery_', [$t('status')]) : $t('returned_', [$t('status')]) }}</div>
                            <span class="subtitle-1">{{ selectedEvent.color === 'green' ? $t('completed') : $t('pending')}}</span>
                        </v-card-text>
                        <v-card-text>
                            <div class="field-label">{{ $tc('timeslot', 1) }}</div>
                            <span class="subtitle-1">{{ selectedEvent.start }} ~ {{ selectedEvent.end }}</span>
                        </v-card-text>
                        <v-card-actions class="justify-center">
                            <v-btn
                                class="text-capitalize"
                                color="primary"
                                @click="openRescheduleDialog = true"
                            > {{ $t('reschedule') }}</v-btn>
                        </v-card-actions>
                    </v-card>
                </v-menu>
            </v-sheet>
        </v-col>

        <v-dialog
            v-if="openCreateDialog"
            v-model="openCreateDialog"
            width="360"
        >
            <v-card>
                <v-card-text class="pa-2">
                    <timeslot-form
                        :types="timeslotTypes"
                        :loading="loading"
                        :errors="timeslotErrors"
                        @validated="createTimeslot"
                    ></timeslot-form>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="selectedTimeslot"
            v-model="openEditDialog"
            width="360"
            @click:outside="onEditClose"
        >
            <v-card>
                <v-card-text class="pa-2">
                    <timeslot-form
                        mode="edit"
                        :timeslot="selectedTimeslot"
                        :types="timeslotTypes"
                        :loading="loading"
                        :errors="timeslotErrors"
                        @validated="editTimeslot"
                    ></timeslot-form>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="selectedEvent"
            v-model="openRescheduleDialog"
            width="320"
        >
            <v-card>
                <v-card-title class="title primary white--text">
                    {{ $t('timeslot_', [$t('reschedule')]) }}
                </v-card-title>
                <v-card-text class="pa-4">
                    <v-select
                        dense
                        outlined
                        hide-details
                        item-value="id"
                        v-model="selectedEvent.timeslot"
                        :items="timeslots"
                        :loading="loading"
                    >
                        <template slot="selection" slot-scope="data">
                            <v-chip
                                small
                                label
                                class="mr-2"
                                color="primary"
                                text-color="white"
                            >
                                {{ $t(data.item.type.name) }}
                            </v-chip>
                            {{ data.item.start_time | time }} ~ {{ data.item.end_time | time }}
                        </template>
                        <template slot="item" slot-scope="data">
                            <v-chip
                                small
                                label
                                class="mr-2"
                                color="primary"
                                text-color="white"
                            >
                                {{ $t(data.item.type.name) }}
                            </v-chip>
                            {{ data.item.start_time | time }} ~ {{ data.item.end_time | time }}
                        </template>
                    </v-select>
                    <v-menu
                        ref="datePicker"
                        :close-on-content-click="false"
                        :nudge-right="40"
                        transition="scale-transition"
                        offset-y
                        min-width="290px"
                    >
                        <template v-slot:activator="{ on, attrs }">
                            <v-text-field
                                class="pt-4"
                                v-model="selectedEvent.date"
                                :loading="loading"
                                prepend-inner-icon="mdi-calendar"
                                hide-details="auto"
                                v-bind="attrs"
                                v-on="on"
                                readonly
                                dense
                                outlined
                            ></v-text-field>
                        </template>
                        <v-date-picker
                            v-model="selectedEvent.date"
                            @input="$refs.datePicker.save(selectedEvent.date)"
                        ></v-date-picker>
                    </v-menu>
                </v-card-text>
                <v-card-actions class="justify-center">
                    <v-btn
                        class="text-capitalize"
                        color="primary"
                        :loading="loading"
                        @click="reschedule"
                    >
                        {{ $t('confirm') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="selectedTimeslot"
            v-model="openDeleteDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('delete_', [$tc('timeslot', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('del_desc_1') }}</p>
                    <p>{{ $t('del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="onDeleteClose"
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        color="primary"
                        text
                        :loading="loading"
                        @click="deleteTimeslot"
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import TimeslotForm from "./TimeslotForm";
    import { mapMutations } from "vuex";
    import DataTable from "../DataTable";
    import moment from "moment";
    import OrderStatus from "../../../constants/order"

    export default {
        name: "Timeslot",
        components: {DataTable, TimeslotForm},
        data: () => ({
            focus: '',
            type: 'month',
            loading: false,
            timeslots: [],
            timeslotTypes: [],
            timeslotErrors: [],
            openCreateDialog: false,
            openEditDialog: false,
            openDeleteDialog: false,
            selectedTimeslot: {},
            selectedEvent: {},
            selectedElement: null,
            selectedOpen: false,
            forceFetch: false,
            eventLoading: false,
            openRescheduleDialog: false,
            weekdays: [1, 2, 3, 4, 5],
            events: [],
        }),
        async created() {
            this.fetchTypes()
                .then(data => {
                    this.timeslotTypes = data;
                })
        },
        mounted () {
            this.$refs.calendar.checkChange()
        },
        computed: {
            headers() {
                return [
                    { text: this.$t('type'), value: 'type', sortable: false },
                    { text: this.$t('start_time'), value: 'start_time', sortable: false },
                    { text: this.$t('end_time'), value: 'end_time', sortable: false },
                    { text: this.$t('limit'), value: 'limit', align: 'right', sortable: false },
                    { text: this.$t('status'), value: 'enabled', align: 'center', sortable: false },
                ]
            },
            typeToLabel() {
                return {
                    month: this.$t('month'),
                    week: this.$t('week'),
                    day: this.$t('day')
                }
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            viewDay ({ date }) {
                this.focus = date
                this.type = 'day'
            },
            setToday () {
                this.focus = ''
                this.type = 'day'
            },
            prev () {
                this.$refs.calendar.prev()
            },
            next () {
                this.$refs.calendar.next()
            },
            getEventColor(event) {
                return event.color
            },
            showEvent ({ nativeEvent, event }) {
                const open = () => {
                    this.selectedEvent = event
                    this.selectedElement = nativeEvent.target
                    setTimeout(() => {
                        this.selectedOpen = true
                    }, 10)
                }

                if (this.selectedOpen) {
                    this.selectedOpen = false
                    setTimeout(open, 10)
                } else {
                    open()
                }

                nativeEvent.stopPropagation()
            },
            async updateRange ({ start, end }) {
                this.eventLoading = true

                const events = await this.fetchEvents(this.filterOption(start.date))

                this.events = events.map(e => this.mapEvent(e))

                this.eventLoading = false
            },
            fetchTypes() {
                return new Promise((resolve, reject) => {
                    axios.get('api/timeslots/types')
                        .then(({ data }) => {
                            resolve(data)
                        })
                        .catch(({ response }) => {
                            reject(response.data)
                        })
                })
            },
            filterOption(date) {
                if(this.type === 'month') {
                    return {
                        month: moment(date).format('Y-M')
                    }
                }
                else if(this.type === 'day') {
                    return {
                        day: date
                    }
                }

                return {
                    week: date
                }
            },
            fetchEvents(filter) {
                return new Promise((resolve, reject) => {
                    axios.get('api/timeslots/events', {
                        params: {
                            per_page: -1,
                            filter: filter
                        }
                    })
                        .then(({ data }) => {
                            resolve(data.data)
                        })
                        .catch(({ response }) => {
                            reject(response.data)
                        })
                })
            },
            createTimeslot(payload) {
                this.loading = true

                axios.post('api/timeslots', payload)
                    .then(() => {
                        this.forceFetch = true
                        this.openCreateDialog = false
                        this.timeslotErrors = []
                        this.success(this.$t('timeslot_action.created'))
                    })
                    .catch(({ response }) => {
                        if(response.status === 422) {
                            this.timeslotErrors = response.data.errors
                        }
                        else {
                            this.error(response.data.message)
                        }
                    })
                    .finally(() => {
                        this.loading = false
                    })
            },
            editTimeslot(payload) {
                this.loading = true

                axios.put(`api/timeslots/${this.selectedTimeslot.id}`, payload)
                    .then(() => {
                        this.forceFetch = true
                        this.onEditClose()
                        this.timeslotErrors = []
                        this.success(this.$t('timeslot_action.updated'))
                    })
                    .catch(({ response }) => {
                        if(response.status === 422) {
                            this.timeslotErrors = response.data.errors
                        }
                        else {
                            this.error(response.data.message)
                        }
                    })
                    .finally(() => {
                        this.loading = false
                    })
            },
            deleteTimeslot() {
                this.loading = true

                axios.delete(`api/timeslots/${this.selectedTimeslot.id}`)
                    .then(() => {
                        this.forceFetch = true
                        this.onDeleteClose()
                        this.timeslotErrors = []
                        this.success(this.$t('timeslot_action.deleted'))
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message)
                    })
                    .finally(() => {
                        this.loading = false
                    })
            },
            onEdit(item) {
                this.openEditDialog = true
                this.selectedTimeslot = item
            },
            onEditClose() {
                this.selectedTimeslot = {}
                this.openEditDialog = false
            },
            onDelete(item) {
                this.openDeleteDialog = true
                this.selectedTimeslot = item
            },
            onDeleteClose() {
                this.selectedTimeslot = {}
                this.openDeleteDialog = false
            },
            reschedule() {
                this.loading = true

                axios.put(`api/timeslots/${this.selectedEvent.id}/reschedule`, {
                    timeslot: this.selectedEvent.timeslot,
                    date: this.selectedEvent.date
                })
                    .then(({ data }) => {
                        const index = this.events.findIndex(e => e.id === this.selectedEvent.id)
                        this.$set(this.events, index, this.mapEvent(data))
                        this.openRescheduleDialog = false
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message)
                    })
                    .finally(() => {
                        this.loading = false
                    })
            },
            eventColor(event){
                console.log(event)
                if(event.order){
                    if(event.order.status.id === OrderStatus.DELIVERED && event.name === 'deliver') return 'green'
                    if(event.order.status.id === OrderStatus.COMPLETED) return 'green'
                    if(event.order.status.id === OrderStatus.REJECTED) return 'red'
                    return event.name === 'deliver' ? 'orange' : 'blue'
                }
                else{
                    return event.name === 'deliver' ? 'orange' : 'blue'
                }
            },
            mapEvent(event) {
                return {
                    id: event.id,
                    name: this.$t(event.name),
                    color: this.eventColor(event),
                    start: moment(event.start).local().format('YYYY-MM-DD H:mm'),
                    end: moment(event.end).local().format('YYYY-MM-DD H:mm'),
                    date: event.date,
                    timeslot: event.timeslot_id,
                    order_id: event.order_id
                }
            }
        }
    }
</script>

<style scoped>

</style>
